; TMTLSTUB v. 3.00
; 03.Jul.1999

;**** General directives ****************************************************

.386
.alpha
        locals  @@
        assume  cs:code, ds:data, ss:stacks, es:nothing

;**** Data segment **********************************************************

data    segment  byte use16

exec_struct struc
        envseg  dw ?
        cmdlineptr dd ?
        fcb1ofs dw ?
        fcb1seg dw ?
        fcb2ofs dw ?
        fcb2seg dw ?
exec_struct ends

exec_block exec_struct <0, cmd_line, 5Ch, 0, 6Ch,0>

path_offset     dw 0FFFFh               ; 'PATH' variable offset in
                                        ; environment block

errmsg4         db '386 required$'
errmsg2         db 'Memory allocation error$'
errmsg1         db 'TMTL.EXE not found$'
errmsg3         db 'DOS EXEC failed$'
crlf            db 13, 10, '$'

all_paths       db 0

loader_path     db 'TMTL.EXE', 0
                db 119 dup(?)
cmd_line        db 128 dup(?)

prefix_seg      dw ?
env_block       dw ?
new_env_block   dw ?
env_length      dw ?

data    ends

;**** Code segment **********************************************************

code    segment  byte use16

copyleft        db 'TMTLSTUB v. 3.00 Coded by Asp //VRg, 1998-1999'

main    proc far
                                        ; Startup code
        mov     ax, data
        mov     ds, ax
                                        ; Get prefix seg and set TMTLOAD flag
        mov     prefix_seg, es
        mov     byte ptr es:[4], 33h
                                        ; Check if we are on 386
        pushf
        pushf
        pop     ax
        xor     ah, 40h
        push    ax
        popf
        pushf
        pop     bx
        popf
        cmp     ah, bh
        je      @@386_present
        lea     dx, errmsg4
        jmp     abort
@@386_present:
                                        ; Resize program's memory block
        mov     bx, stacks
        mov     ax, prefix_seg
        sub     bx, ax
        add     bx, 4
        mov     ah, 4Ah
        int     21h
        jnc     @@no_resize_err
        lea     dx, errmsg2
        jmp     abort
@@no_resize_err:
                                        ; Preserve program command line
        cld
        push    ds
        push    ds
        pop     es
        mov     ds, prefix_seg
        mov     si, 80h
        lea     di, cmd_line
        mov     cx, 32
        rep     movsd
                                        ; Calculate environment size and PATH
                                        ; variable offset
        mov     ax, ds:[2Ch]
        pop     ds
        mov     env_block, ax
        mov     es, ax
        xor     di, di
        xor     al, al
        dec     cx                      ; 0 - 1 = 0FFFFh
@@1:
        cmp     dword ptr es:[di], 'HTAP'
        jne     @@skip
        cmp     byte ptr es:[di+4], '='
        jne     @@skip
        mov     path_offset, di
        add     path_offset, 5
@@skip:
        cmp     byte ptr es:[di], 0
        je      @@2
        repnz   scasb
        jmp     short @@1
@@2:
        not     cx
        mov     env_length, cx
                                        ; Search for TMTL.EXE on path
        lea     dx, loader_path
        mov     cx, 47
        mov     ah, 4Eh
        int     21h
        jnc     @@found
        cmp     path_offset, 0FFFFh
        je      @@not_found
        push    ds
        pop     es
        mov     si, path_offset
@@get_next_path:
        push    ds
        mov     ds, env_block
        lea     di, loader_path
@@get_character:
        movsb
        cmp     byte ptr es:[di-1], ';'
        je      @@one_path_get
        cmp     byte ptr es:[di-1], 0
        je      @@all_paths_get
        jmp     short @@get_character
@@all_paths_get:
        mov     es:all_paths, 1
@@one_path_get:
        cmp     byte ptr es:[di-2], '\'
        jne     @@append_backslash
        dec     di
        jmp     short @@append_loader_name
@@append_backslash:
        mov     byte ptr es:[di-1], '\'
@@append_loader_name:
        pop     ds
        push    si
        lea     si, errmsg1
        movsd
        movsd
        mov     byte ptr [di], 0
        pop     si
        mov     ah, 4Eh                 ; dx and cx unchanged
        int     21h
        jnc     @@found
        cmp     all_paths, 1
        jne     @@get_next_path
@@not_found:
        lea     dx, errmsg1             ; TMTL not found
        jmp     abort
@@found:
                                        ; Create new environment
                                        ; First get memory for new environment
        mov     cx, env_length
        add     cx, 256
        shr     cx, 4
        mov     bx, cx
        mov     ah, 48h
        int     21h
        jnc     @@no_mem_err
        lea     dx, errmsg2
        jmp     short abort
@@no_mem_err:
                                        ; Set TMTLOAD variable
        mov     new_env_block, ax
        mov     es, ax
        mov     di, 8
        mov     dword ptr es:[di-8], 'LTMT'
        mov     dword ptr es:[di-4], '=DAO'
        mov     si, env_length
        mov     cx, si
        add     si, 3
        inc     cx
        push    ds
        mov     ds, env_block
@@loop:
        movsb
        cmp     byte ptr es:[di-1], 0
        jne     @@loop
                                        ; Move the rest of environment
        xor     si, si
        rep     movsb
        pop     ds
                                        ; Fill EXEC control block
        mov     ax, prefix_seg
        mov     exec_block.fcb1seg, ax
        mov     exec_block.fcb2seg, ax
        mov     ax, new_env_block
        mov     exec_block.envseg, ax
                                        ; Invoke TMTL.EXE
        push    ds
        pop     es
        lea     dx, loader_path
        lea     bx, exec_block
        mov     ax, 4B00h
        int     21h
        jc      @@error
                                        ; Free new environment block
        mov     es, new_env_block
        mov     ah, 49h
        int     21h
                                        ; Get exit code
        mov     ah, 4Dh
        int     21h
                                        ; Terminate
        mov     ah, 4Ch
        int     21h
@@error:
        mov     es, new_env_block
        mov     ah, 49h
        int     21h
        lea     dx, errmsg3
        jmp     short abort
main    endp

abort:
        mov     ah, 09h
        int     21h
        lea     dx, crlf
        int     21h
        mov     ax, 4CFFh
        int     21h
code    ends

;**** Stack segment *********************************************************

stacks  segment  word use16 stack
                db 64 dup(?)
stacks  ends

end     main
